﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Runtime.Serialization.Json;
using System.IO;

/// <summary>
/// Summary description for DefaultViewModel
/// </summary>
public class BuildViewModel
{
    private string _pants = null;
    private string _shirts = null;

    public string Pants
    { 
        get 
        {
            if (this._pants == null)
            {
                JsonSerializer<IList<Garment>> s = new JsonSerializer<IList<Garment>>();
                this._pants = s.Serialize(this.GetPants());
            }
            return this._pants;
        }

        set { this._pants = value; }
    }

    public string Shirts
    {
        get 
        {
            if (this._shirts == null)
            {
                var s = new JsonSerializer<IList<Garment>>();
                this._shirts = s.Serialize(this.GetShirts());
            }
            return this._shirts;
        }
        set { this._shirts = value; }
    }

    #region Fake Data
    private IList<Garment> GetShirts()
    {
        IList<Garment> shirts = new List<Garment>();

        shirts.Add(new Garment()
        {
            Description = "The pink piggies make a perfect addition to any ensemble. Hand woven and lovingly crafted with a realistically mud-colored brown background. A must for any barn raising.",
            FileName = "shirt2",
            FileNameFull = "shirt2.png",
            GarmentId = 2,
            Title = "Muddy Paradise"
        });

        shirts.Add(new Garment()
        {
            Description = "Do you stop? Do you go? Do you exercise caution? Did you slay a bengal tiger, perhaps? Keep motorists and small children guessing with this stylish top.",
            FileName = "shirt4",
            FileNameFull = "shirt4.png",
            GarmentId = 4,
            Title = "Color Bastion"
        });

        shirts.Add(new Garment()
        {
            Description = "Depression is the number one cause of depressed giraffes in America today. Now you can make a difference by showing your support for your sad long-necked friends.",
            FileName = "shirt6",
            FileNameFull = "shirt6.png",
            GarmentId = 6,
            Title = "Geoffrey's Slump"
        });

        shirts.Add(new Garment()
        {
            Description = "Remember the last time you went to grandma's house and you thought to yourself, 'I wonder what she would do with all this left over fabric that doesn't really go with anything?' Well, welcome to your new blouse.",
            FileName = "shirt7",
            FileNameFull = "shirt7.png",
            GarmentId = 7,
            Title = "Grandma Tripped"
        });

        shirts.Add(new Garment()
        {
            Description = "You are never too old to feel like, nay, BE a star! This dazzling top screams fashion know-how.",
            FileName = "shirt8",
            FileNameFull = "shirt8.png",
            GarmentId = 8,
            Title = "Little Sparkles"
        });

        shirts.Add(new Garment()
        {
            Description = "Lady Ga Ga, who? Thanksgiving will never be the same in this characteristic slinky and tin foil-inspired top.",
            FileName = "shirt9",
            FileNameFull = "shirt9.png",
            GarmentId = 9,
            Title = "Super Space Star"
        });

        shirts.Add(new Garment()
        {
            Description = "Angry that mom and dad wouldn't let Jenna keep the bunnies, she decided to make a statement. Finally this replica can be in heavy rotation in your wardrobe too.",
            FileName = "shirt10",
            FileNameFull = "shirt10.png",
            GarmentId = 10,
            Title = "Thumpers"
        });

        return shirts;
    }

    private IList<Garment> GetPants()
    {
        IList<Garment> pants = new List<Garment>();

        pants.Add(new Garment()
        {
            Description = "Let those around you know exactly how you feel with this unique and, occasionally accurate, pair of mood pants.",
            FileName = "pant1",
            FileNameFull = "pant1.png",
            GarmentId = 1,
            Title = "Moodies"
        });

        pants.Add(new Garment()
        {
            Description = "If you are in search for utility with style, look no further. These pants feature a series of 5 difficult-to-unfasten buttons in the front and mesmerizing stripes throughout.",
            FileName = "pant2",
            FileNameFull = "pant2.png",
            GarmentId = 2,
            Title = "Tron Gone"
        });

        pants.Add(new Garment()
        {
            Description = "Simply put, jeans so tight you get younger the more you wear them.",
            FileName = "pant3",
            FileNameFull = "pant3.png",
            GarmentId = 3,
            Title = "DocBrown's"
        });

        pants.Add(new Garment()
        {
            Description = "Do you have a need to keep your platforms on while you change your trousers? These big bells give you enough room to hide small children in your boots.",
            FileName = "pant4",
            FileNameFull = "pant4.png",
            GarmentId = 4,
            Title = "Liberty Bells"
        });

        pants.Add(new Garment()
        {
            Description = "Disorient burglars, wild boars and angry soccer moms with these hypnotic bottoms.",
            FileName = "pant5",
            FileNameFull = "pant5.png",
            GarmentId = 5,
            Title = "Garden Explosion"
        });

        pants.Add(new Garment()
        {
            Description = "These flattering pink pants keep the promise that sleep-sheep around the world will never be overworked again.",
            FileName = "pant6",
            FileNameFull = "pant6.png",
            GarmentId = 6,
            Title = "Save the Sheep"
        });

        pants.Add(new Garment()
        {
            Description = "If you despise holiday parties just wear these slacks to the next get together and rest assured next year's invite will mysteriously 'disappear'.",
            FileName = "pant7",
            FileNameFull = "pant7.png",
            GarmentId = 7,
            Title = "Angry Elf"
        });

        return pants;
    }
    #endregion

    public BuildViewModel() { }
}
